Program Flori;

Type Multime = Set Of Byte;

Var F, G: Array[1..150] Of Multime;   {F - fetitele; G - grupele}
    n, k: Byte;
    Fin, Fout: TExt;

Procedure Init;                       {initializez multimile}
Var i: Byte;                          {cu multimea vida}
Begin
  For i := 1 To n Do
    Begin
      F[i] := [];
      G[i] := []
    End
End;

Procedure Citeste;
Var i, j, x: Byte;
Begin
  Assign(Fin, 'flori.in'); Reset(Fin);
  ReadLn(Fin, n, k);                  {citesc n si k}
  Init;                               {initializez multimile}
  For i := 1 To n Do                  {pentru fiecare fetita}
    For j := 1 To k Do
      Begin
        Read(Fin, x);                    {citesc cele k flori}
        F[i] := F[i]+[x]                 {si le retin tipul}
      End;
  Close(Fin)
End;

Procedure FaGrupe;
Var i, j: Byte;
    SaFacut: Boolean;
Begin
  For i := 1 To n Do                  {pentru fiecare fetita}
    Begin
      SaFacut := FALSE;               {inca nu a gasit alta fetita cu flori comune}
      If F[i]<>[] Then                {daca are cel putin o floare}
        Begin
          G[i] := G[i]+[i];             {o adaug la grupul i}
          For j := i+1 To n Do          {verific toate fetitele ce urmeaza}
            If F[i]*F[j]<>[] Then          {daca fetitele i si j au flori comune}
              Begin
                G[i] := G[i]+[j];            {adaug fetita j la grupul i}
                F[i] := F[i]+F[j];           {reunesc florile si le pun la fetita i}
                F[j] := [];                  {am luat toate forile fetitei j}
                SaFacut := TRUE              {am facut o reuniune}
              End;
          If SaFacut Then i := i-1      {daca s-a facut cel putin o reuniune}
        End                             {mai trec o data prin grupul de fetite}
    End;                                {care urmeaza fetitei i, ea ramane pe loc}
End;

Procedure Afiseaza;
Var i, j: Byte;
Begin
  Assign(Fout, 'flori.out'); ReWrite(Fout);
  For i := 1 To n Do                    {trec pe la toate posibilele grupe}
    If G[i]<>[] Then                    {daca grupa i are cel putin o fetita}
      Begin
        For j := 1 To 150 Do              {afisez fetitele in ordine crescatoare}
          If j in G[i] Then               {daca fetita j este in grupul i}
            Write(Fout, j, ' ');             {afiseaz-o}
        WriteLn(Fout)
      End;
  Close(Fout)
End;


Begin
  Citeste;
  FaGrupe;
  Afiseaza
End.

