Program Pluton;

Type TCifre = Array[0..9] Of 0..10;

Const MAX = 4000;
Var Fin, Fout: Text;
    a: Array[1..MAX] Of LongInt;
    b, c: Array[1..MAX] Of Byte;
    Pus: Array[1..MAX] Of Boolean;
    G: Array[1..MAX, 0..1] Of LongInt;
    Cifre, cifreTest: TCifre;
    n, Nre, NrG, maxe, btest, ctest: LongInt;
    OK: Boolean;

Function ToatePuse: Boolean;
Var i: Integer;
    x: Boolean;
Begin
  x := TRUE;
  For i := 1 To n Do
    x := x AND Pus[i];
  ToatePuse := x
End;

Procedure Cifrele(x: LongInt; Var c: Tcifre);
Var j: Integer;
Begin
{  For j := 0 To 9 Do c[j] := 0;}
  FillChar(c, SizeOf(c), 0);
  While x>0 Do
    Begin
      Inc(c[x MOD 10]);
      x := x DIV 10;
    End;
End;

Procedure Citire;
Var i, j: Integer;
    x: LongInt;
Begin
  ReadLn(Fin, n);
  For i := 1 To n Do
    Begin
       Read(Fin, a[i]);

    {construiesc 2 vectori ajutatori
  - vectorul b care va contine numarul de cifre al fiecarui element
  - vectorul c care va contine numarul de cifre distincte a fiecarui element}
       {For j := 0 To 9 Do Cifre[j] := 0;}
       FillChar(Cifre, SizeOf(Cifre), 0);
       x := a[i];
       While x>0 Do
         Begin
           b[i] := b[i]+1;      {numar total de cifre}
           Cifre[x Mod 10] := 1;
           x := x Div 10
         End;
       For j := 0 To 9 Do
         c[i] := c[i]+Cifre[j]; {numar de cifre distincte}
     End;
End;

Procedure Sortare;
Var i, j: Integer;
    min, pm, x, aux: LongInt;
Begin
{ordonez cei trei vectori crescator dupa numarul de cifre (dupa b)
si dupa numarul de cifre distincte, deci cheia de sortare va fi un numar
construit dupa formula b[i]*10+c[i] }
  For i := 1 To n-1 Do
    Begin
      min := b[i]*10+c[i]; pm := i;
      For j := i+1 To n Do
        Begin
          x := b[j]*10+c[j];
          If x<min Then
            Begin
              min := x; pm := j
            End;
        End;
      aux := c[i]; c[i] := c[pm]; c[pm] := aux;
      aux := b[i]; b[i] := b[pm]; b[pm] := aux;
      aux := a[i]; a[i] := a[pm]; a[pm] := aux;
    End;
End;

Procedure FormarePlutoane;
Var i, j: Integer;
Begin
{formez si numar plutoanele
  - plutoanele le voi retine pe linii distincte a matricii G
  - in fiecare linie, elementul 0 va contine numarul de elemente din pluton
    iar elementul 1 reprezentantul plutonului, primul care apare in a}
  While Not ToatePuse Do
    Begin
      i := 1;
      While Pus[i] Do Inc(i);  {caut primul nepus inca}
      {retinem primul element nepus din pluton cu caracteristicile lui}
      btest := b[i]; ctest := c[i];
      NrG := NrG+1; G[NrG, 0] := 1;
      G[NrG, 1] := a[i]; Pus[i] := TRUE; {il pun in pluton}
      Cifrele(a[i], cifreTest);{retin cifrele in cifreTest[]}
      {verific elementele cu aceleasi caracteristici daca fac parte din
      acelasi pluton cu primul element pe care l-am retinut}
      i := i+1;
      While (b[i]=btest) AND (c[i]=ctest) AND (i<=n) Do
        Begin                  {ar putea face parte din acelasi pluton}
          Cifrele(a[i], cifre);{aflu cifrele in cifre[]}
          OK := TRUE;          {testez daca are aceleasi cifre}
          For j := 0 To 9 Do
            If cifreTest[j]<>cifre[j] Then OK := FALSE;
          If OK Then           {are aceleasi cifre}
            Begin
              Inc(G[NrG, 0]);  {un nou soldat in pluton}
              Pus[i] := TRUE;  {l-am pus}
            End;
          i := i+1
        End;
    End;
End;

Procedure Afisare;
Var i, j: Integer;
    x: LongInt;
Begin
  WriteLn(Fout, NrG);        {cerinta 1}
  maxe := 0;   {determin numarul maxim de elemente ale unui pluton}
  For i := 1 To n Do
    If G[i, 0]>maxe Then
      Begin
        maxe := G[i, 0];
        x := G[i, 1]         {retin reprezentantul plutonului numeros}
      End;
  WriteLn(Fout, maxe);       {cerinta 2}
  Nre := 0;
  For i := 1 To NrG Do
    If G[i, 0]=maxe Then
      Nre := Nre+1;
  WriteLn(Fout, Nre);        {cerinta 3}

  i := 1;
  While x<>a[i] Do Inc(i);   {il caut in a}
  Write(Fout, a[i], ' ');    {scriu reprezentantul plutonului}
  btest := b[i]; ctest := c[i]; {retin caracteristicile}
  Cifrele(a[i], cifreTest);  {aflu cifrele}

  Inc(i);                    {cerinta 4}
  While (b[i]=btest) AND (c[i]=ctest) AND (i<=n) Do
    Begin                    {ar putea face parte din acelasi pluton}
      Cifrele(a[i], cifre);  {aflu cifrele}
      OK := TRUE;            {testez daca are aceleasi cifre}
      For j := 0 To 9 Do
        If cifreTest[j]<>cifre[j] Then OK := FALSE;
      If OK Then             {are aceleasi cifre}
        Write(Fout, a[i], ' '); {il afisez }
      i := i+1
    End;

  WriteLn(Fout);
End;

Begin
  Assign(Fin, 'pluton.in'); Reset(Fin);{deschid fisierul 'pluton.in' pentru citire}
  Assign(Fout, 'pluton.out'); ReWrite(Fout);{deschid fisierul 'pluton.out' pentru scriere}
  Citire;
  Sortare;
  FormarePlutoane;
  Afisare;
  Close(Fin);
  Close(Fout);
End.
