#include <fstream.h>
#include <conio.h>

int verif(long int a,long int b)
// verifica daca a si b au aceleasi cifre
{  int x[10],y[10],i;
   memset(x,0,sizeof(x));  // x[i] retine numarul de cifre de i din a
   memset(y,0,sizeof(y));  // y[i] retine numarul de cifre de i din b 
   while (a)
   {  x[a%10]++;
      a/=10;
   }
   while (b)
   {  y[b%10]++;
      b/=10;
   }
   for (i=0;i<10;i++)
     if (x[i]!=y[i])
       return 0;
   return 1;
}

void main()
{  long int x[4000],t;
   int y[4000],z[4000],a[4000],b[4000],urm[4000],max,q,i1,j,p;
   memset(x,0,sizeof(x)); // numerele de identificare ale soldatilor
   memset(y,0,sizeof(y)); // bitul j, j=0,1,...,9, a lui y[i] este 1 daca
			  // x[i] contine cifra j
   memset(z,0,sizeof(z)); // z[i] = numarul de cifre (distincte sau nu) din x[i]
   memset(a,0,sizeof(a)); // a[i] = numaarum plutonului din care face parte i
    // soldatii i si j fac parte din acelasi pluton daca:
    // 1. y[i]=y[j], adica au aceleasi cifre distincte
    // 2. z[i]=z[j], adica au acelasi numar total de cifre
    // dar aceste doua conditii nu sunt suficiente (vezi de exemplu 112 si 122)
    // 3. verif(x[i],y[j])=1, adica au exact aceleasi cifre
   memset(b,0,sizeof(b));
   memset(urm,0,sizeof(urm)); // urm[i] memoreaza indicele urmatorului soldat
			      // din acelasi pluton cu i

   int n,i,k;
   ifstream f("pluton.in");
   f>>n;  // numarul de soldati
   for (i=0;i<n;i++)
   {  f>>x[i];
      k=0;
      t=x[i];
      y[i]=0; z[i]=0;
      while (t)
      {  y[i]=y[i] | (1<<(t%10));
	 t=t/10; z[i]++;
      }
   }
   t=0;         // t = numarul total de plutoane
   max=0;       // max = numarul maxim de soldati dintr-un pluton  
   q=0;         // p = indicele primului soldat din plutonul cu numar maxim de soldati
                // q = numarul de putoane cu numar maxim de soldati 
   for (i=0;i<n;i++)
     if (a[i]==0)
     { i1=i; t++;
       k=1; a[i]=t;
       for (j=i+1;j<n;j++)
	 if ((a[j]==0)&&(y[i]==y[j])&&(z[i]==z[j]))
	 {  if (verif(x[i],x[j]))
	    {  a[j]=t;
	       urm[i1]=j;
	       i1=j;
	       k++;
	    }
	 }
       if (k>max) { max=k; p=i; q=1; }
       else
	 if (k==max)
	   q++;
     }
   ofstream g("pluton.out");
   g<<t<<endl;
   g<<max<<endl;
   g<<q<<endl;
   i=p;
   do
   {  g<<x[i]<<" ";
      i=urm[i];
   } while (i!=0);
   g.close(); f.close();
}

